var Auth = {
	logined: function() {
		var status = plus.storage.getItem('LOGINSTATUS') || "false";
		if(status == "true")
			return true;
		else
			return false;
	},

	check: function() {
		mui.get(api.check_login, null, function(data) {
			dd("check login:", data);
			if(data) {
				plus.storage.setItem('LOGINSTATUS', "true");
			} else {
				plus.storage.setItem('LOGINSTATUS', "false");
			}
		}, "json");
	},

	clientInfo: function() {
		return plus.push.getClientInfo();
	},

	openLogin: function() {
			mui.openWindow({
			url: "_www/pages/member/login.html",
			id: "login",
			createNew: false,
			styles: {
				top: 0,
				bottom: 0,
				width: "100%",
				titleNView: {
					titleText: "会员登录",
					backgroundColor: "#24b34a",
					titleColor: '#ffffff',
					titleSize: "16px",
					autoBackButton:true
				}
			},
			show: {
				autoShow: true,
				aniShow: "pop-in",
				duration: 200
			}
		});
	},

	userLogin: function(loginInfo) {
		loginInfo = loginInfo || {};
		account = loginInfo.account || '';
		password = loginInfo.password || '';

		if(account.length < 3) {
			plus.nativeUI.toast("'账号最短为 3 个字符'");
			return false;
		}

		if(password.length < 6) {
			plus.nativeUI.toast("密码最短为 6 个字符");
			return false;
		}
		this.login(account, password);
	},

	checkEmail: function(email) {
		email = email || '';
		return(email.length > 3 && email.indexOf('@') > -1);
	},

	//验证用户名
	verifyUsername: function(username) {
		var is_true = 0;
		if(/^1(3|4|5|7|8)\d{9}$/.test(username)) {
			is_true = 1;
			plus.nativeObj.toast("请输入正确的手机号");
			return is_true;
		}
		return is_true;
	},

	//验证密码
	verifyPassword: function(password) {
		var is_true = 0;
		var min_length = 6;

		if(password.trim() == "") {
			is_true = 1;
			plus.nativeObj.toast("密码不能为空");
			return is_true;
		}

		if(password.length < min_length) {
			is_true = 1;
			plus.nativeObj.toast("密码不能小于6位数");
			return is_true;
		}

		if(/.*[\u4e00-\u9fa5]+.*$/.test(password)) {
			is_true = 1;
			mui.alert("密码不能包含中文");
			return is_true;
		}
		var regex_str = "";
		if(regex_str.trim() != "") {
			//验证是否包含数字
			if(regex_str.indexOf("number") >= 0) {
				var number_test = /[0-9]/;
				if(!number_test.test(password)) {
					is_true = 1;
					mui.alert("password_must_contain_numbers");
					return is_true;
				}
			}
			//验证是否包含小写字母
			if(regex_str.indexOf("letter") >= 0) {
				var letter_test = /[a-z]/;
				if(!letter_test.test(password)) {
					is_true = 1;
					mui.alert("password_must_have_lowercase_letters");
					return is_true;
				}
			}
			//验证是否包含大写字母
			if(regex_str.indexOf("upper_case") >= 0) {
				var upper_case_test = /[A-Z]/;
				if(!upper_case_test.test(password)) {
					is_true = 1;
					mui.alert("password_must_have_uppercase_letters");
					return is_true;
				}
			}
			//验证是否包含特殊字符
			if(regex_str.indexOf("symbol") >= 0) {
				var symbol_test = /[^A-Za-z0-9]/;
				if(!symbol_test.test(password)) {
					is_true = 1;
					mui.alert("password_must_contain_symbols");
					return is_true;
				}
			}
		}
		return is_true;
	},

	openRegister: function() {
		mui.openWindow({
			url: '_www/pages/member/reg.html',
			id: 'register',
			styles: {
				top: 0,
				bottom: 0,
				width: "100%",
				titleNView: {
					titleText: "会员注册",
					titleSize: "16px",
					backgroundColor: "#24b34a",
					titleColor: '#ffffff',
					autoBackButton:true
				}
			},
			show: {
				autoShow: true,
				aniShow: "pop-in",
				duration: 200
			}
		});
	},

	userRegister: function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.account = regInfo.account || '';
		regInfo.password = regInfo.password || '';
		if(regInfo.account.length < 5) {
			return callback('用户名最短需要 5 个字符');
		}
		if(regInfo.password.length < 6) {
			return callback('密码最短需要 6 个字符');
		}
		if(!checkEmail(regInfo.email)) {
			return callback('邮箱地址不合法');
		}

		return callback();
	},

	openForget: function() {
		mui.openWindow({
			url: '_www/pages/member/forget_password.html',
			id: 'forget_password',
			styles: {
				top: 0,
				bottom: 0,
				width: "100%",
				titleNView: {
					titleText: "忘记密码",
					titleSize: "16px",
					backgroundColor: "#24b34a",
					titleColor: '#ffffff',
					autoBackButton:true
				}
			},
			show: {
				autoShow: true,
				aniShow: "pop-in",
				duration: 200
			}
		});
	},

	forgetPassword: function(email, callback) {
		callback = callback || $.noop;
		if(!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	},

	openRetrieve: function() {
		mui.openWindow({
			url: "_www/pages/member/retrieve_password.html",
			id: "retrieve_password",
			styles: {
				top: 0,
				bottom: 0,
				width: "100%",
				titleNView: {
					titleText: "设置新密码",
					titleSize: "16px",
					backgroundColor: "#24b34a",
					titleColor: '#ffffff',
					autoBackButton:true
				}
			},
			show: {
				autoShow: true,
				aniShow: "pop-in",
				duration: 200
			},
			extras: {
				mobile: mobile,
				code: code
			},
			creatNew: true

		});

	},

	isInstalled: function(id) {
		if(id === 'qihoo' && mui.os.plus) {
			return true;
		}
		if(mui.os.android) {
			var main = plus.android.runtimeMainActivity();
			var packageManager = main.getPackageManager();
			var PackageManager = plus.android.importClass(packageManager)
			var packageName = {
				"qq": "com.tencent.mobileqq",
				"weixin": "com.tencent.mm",
				"sinaweibo": "com.sina.weibo"
			}
			try {
				return packageManager.getPackageInfo(packageName[id], PackageManager.GET_ACTIVITIES);
			} catch(e) {}
		} else {
			switch(id) {
				case "qq":
					var TencentOAuth = plus.ios.import("TencentOAuth");
					return TencentOAuth.iphoneQQInstalled();
				case "weixin":
					var WXApi = plus.ios.import("WXApi");
					return WXApi.isWXAppInstalled()
				case "sinaweibo":
					var SinaAPI = plus.ios.import("WeiboSDK");
					return SinaAPI.isWeiboAppInstalled()
				default:
					break;
			}
		}
	},
	login: function(username, password) {
		var clientinfo = plus.push.getClientInfo();
		mui.ajax({
			type: "post",
			url: api.login,
			async: true,
			data: {
				"username": username,
				"password": password,
				"token": clientinfo.token,
				"clientid": clientinfo.clientid
			},
			success: function(data) {
				if(data.code > 0) {
					plus.nativeUI.toast("登录成功");
					plus.storage.setItem('LOGINSTATUS', "true");
					plus.webview.close('register');
					plus.webview.close('forget_password');
					plus.webview.close('retrieve_password');
					plus.webview.close('login');
					mui.fire(plus.webview.getLaunchWebview(), "LOGINSTATUS", true);
				} else {
					plus.nativeUI.toast(data.message);
				}
			},
			error: function(xhr, type, errorThrown) {
				console.log(type);
			}
		});
	},

	login_mobile: function(mobile, password, sms_captcha) {
		var clientinfo = plus.push.getClientInfo();
		mui.ajax({
			type: "post",
			url: api.login,
			async: true,
			data: {
				"mobile": mobile,
				"password": password,
				"sms_captcha": sms_captcha,
				"token": clientinfo.token,
				"clientid": clientinfo.clientid
			},
			success: function(data) {
				if(data.code > 0) {
					plus.nativeUI.toast("登录成功");
					plus.storage.setItem('LOGINSTATUS', "true");
					plus.webview.close('register');
					plus.webview.close('forget_password');
					plus.webview.close('retrieve_password');
					plus.webview.close('login');
					mui.fire(plus.webview.getLaunchWebview(), "LOGINSTATUS", true);
				} else {
					plus.nativeUI.toast(data.message);
				}
			},
			error: function(xhr, type, errorThrown) {
				console.log(type);
			}
		});
	}
};