console.log("helper.js is loaded");
var helper = {
	isArray: function(e) {
		return(typeof e == 'object') && e.constructor == Array;
	},

	isString: function(e) {
		return(typeof e == 'string') && e.constructor == String;
	},
	isNumber: function(e) {
		return(typeof e == 'number') && e.constructor == Number;
	},
	isDate: function(e) {
		return(typeof e == 'object') && e.constructor == Date;
	},
	isFunction: function(e) {
		return(typeof e == 'function') && e.constructor == Function;
	},
	isObject: function(e) {
		return(typeof e == 'object') && e.constructor == Object;
	},
	showMemberLogin: function() {
		mui.openWindow({
			url: "_www/pages/member/login.html",
			id: "login",
			createNew: false,
			styles: {
				top: 0,
				bottom: 0,
				width: "100%",
				titleNView: {
					titleText: "会员登录",
					backgroundColor: "#24b34a",
					titleColor: '#ffffff',
					titleSize: "16px",
					autoBackButton: true
				}
			},
			show: {
				autoShow: true,
				aniShow: "pop-in",
				duration: 200
			}
		});
	},

	indexToId: function(e) {
		var id = "";
		switch(e) {
			case 0:
				id = 'index';
				break;
			case 1:
				id = 'classifies';
				break;
			case 2:
				id = 'orders';
				break;
			case 3:
				id = 'member';
				break;
		}
		return id;
	},
	idToIndex: function(e) {
		var index = 0;
		switch(e) {
			case 'index':
				index = 0;
				break;
			case 'classifies':
				index = 1;
				break;
			case 'orders':
				index = 2;
				break;
			case 'member':
				index = 3;
				break;
		}
		return index;
	},

	showSearchByWord: function(text) {
		var keywords = text.app_trim();
		if(keywords == "") {
			mui.toast("请输入关键字");
			return;
		}
		var _url = url.search + keywords;
		var webview_search = plus.webview.create(_url, 'search', {
			titleNView: {
				titleText: "\"" + keywords + "\"的搜索结果",
				titleColor: "#ffffff",
				backgroundColor: color.primary,
				autoBackButton: true
			}
		});
		webview_search.hide();
		helper.setJsFiles(webview_search, ["_www/js/config.js", "_www/js/helper.js", "_www/js/mui.min.js", "_www/api/js/search.js"]);
		webview_search.show("pop-in", 300);
	},

	closeSearchWebview: function() {
		plus.webview.close('search');
	},

	setTitle: function() {
		var view = plus.webview.currentWebview();
		view.setStyle({
			titleNView: {
				titleText: view.getTitle()
			}
		});
	},

	setJsFiles: function(webview, files) {
		//console.log('helper:setJsFiles');
		if(helper.isArray(files))
			for(var i = 0; i < files.length; i++) {
				if(i > 0) {
					webview.appendJsFile(files[i]);
					//console.log('helper:setJsFiles append:' + files[i]);
				} else {
					webview.setJsFile(files[i]);
					//console.log('helper:setJsFiles set:' + files[i]);
				}
			}
		else
			webview.setJsFile(files);
	},

	reload: function(id) {
		var curr = plus.webview.getWebviewById(id);
		//console.log(curr.id + ":" + curr.getURL());
		curr.reload();
	},

	closeNotBase: function() {
		var all = plus.webview.getDisplayWebview();
		for(var i in all) {
			if(!all[i].id.isBaseView()) {
				console.log("close view:" + all[i].id);
				all[i].close();
			}
		}

	},

	toggleTab: function(id, index) {
		helper.closeNotBase();
		var jstring = "var id='" + id + "',index=" + index + ";\n";
		var jstring = jstring + "dd(_auth);dd(_bottombar);dd(_container);\n";
		var jstring = jstring + "if(index == 2 || index == 3) {\n";
		var jstring = jstring + "if(_auth.islogined) {\n";
		var jstring = jstring + "	if(_container.subShow(id))\n";
		var jstring = jstring + "		_bottombar.toggleNView(index);\n";
		var jstring = jstring + "} else {\n";
		var jstring = jstring + "	_auth.openLogin();\n";
		var jstring = jstring + "}\n";
		var jstring = jstring + "}else\n";
		var jstring = jstring + "if(_container.subShow(id))\n";
		var jstring = jstring + "	_bottombar.toggleNView(index);";
		plus.webview.getLaunchWebview().evalJS(jstring);
	},

	openWindow: function(url, id, title, jsfile) {
		if(title == undefined)
			var title = "";
		var view = plus.webview.create(url, id, {
			top: 0, //新页面顶部位置
			bottom: 0, //新页面底部位置
			width: "100%", //新页面宽度，默认为100%
			titleNView: {
				titleText: title, //导航栏标题
				backgroundColor: '#24b34a', //导航栏背景色
				autoBackButton: "true", //自动绘制返回箭头
				titleColor: "#ffffff"
			},
			backButtonAutoControl: "close"
		});
		var jsFiles = ['_www/js/config.js', '_www/js/helper.js', '_www/js/mui.min.js', '_www/api/js/openWindow.js'];
		if(jsfile != undefined && jsfile != "")
			jsFiles.push("_www/api/js/" + jsfile);
		helper.setJsFiles(view, jsFiles);
		view.onerror = function() {
			plus.nativeUI.toast("打开页失败，请检查网络");
		};
		if(title == "")
			view.onloaded = function() {
				view.setStyle({
					titleNView: {
						titleText: view.getTitle()
					}
				});
			}
		view.show("pop-in", 200);
	},

	bindOpenWindow: function(classname) {
		if(classname == undefined)
			classname = 'body';
		mui(classname).on('tap', '.mui_openWindow', function() {
			this.addEventListener('tap', function() {
				var _href = this.getAttribute("data-href") || "",
					_id = this.getAttribute('data-viewId') || "",
					_checkLogined = this.getAttribute('data-checkLogined') || false,
					loginStatus = plus.storage.getItem('LOGINSTATUS');
				_title = this.title || "";
				if(_href == "")
					_href = this.href;

				if(_id == "")
					_id = this.href;

				if(_checkLogined && loginStatus != "true") {
					this.showMemberLogin();
				} else
					helper.openWindow(_href, _id, _title);
			});
		});
	},

	bindToggleTab: function(classname) {
		if(classname == undefined)
			classname = 'body';
		mui(classname).on('tap', '.mui_toggleTab', function() {
			var id = this.getAttribute("data-tabId");
			var index = this.getAttribute("data-tabIndex");
			helper.toggleTab(id, index);

		});
	},

	checkUpdate: function() {
		var server = prefix + "/index/checkupdate"; //获取升级描述文件服务器地址
		var request = {
			"appid": plus.runtime.appid,
			"version": plus.runtime.version,
			"imei": plus.device.imei
		};
		mui.getJSON(server, request, function(data) {
			if(data.status) {
				plus.nativeUI.confirm(data.note, function(event) {
					if(0 == event.index) {
						plus.runtime.openURL(data.url);
					}
				}, data.title, ["立即更新", "取消"]);
			}
		});
	}

};